-- phpMyAdmin SQL Dump
-- version 4.7.9
-- https://www.phpmyadmin.net/
--
-- Hôte : 127.0.0.1:3307
-- Généré le :  lun. 04 juin 2018 à 11:17
-- Version du serveur :  10.2.14-MariaDB
-- Version de PHP :  5.6.35

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Base de données :  `entrepot`
--

-- --------------------------------------------------------

--
-- Structure de la table `horaire`
--

DROP TABLE IF EXISTS `horaire`;
CREATE TABLE IF NOT EXISTS `horaire` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `login` varchar(22) NOT NULL,
  `jour` date NOT NULL,
  `debut` time NOT NULL,
  `fin` time NOT NULL,
  PRIMARY KEY (`id`),
  KEY `login` (`login`),
  KEY `jour` (`jour`),
  KEY `debut` (`debut`),
  KEY `fin` (`fin`),
  KEY `periode` (`jour`,`debut`,`fin`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPRESSED;

--
-- Déchargement des données de la table `horaire`
--

INSERT INTO `horaire` (`id`, `login`, `jour`, `debut`, `fin`) VALUES
(1, 'dendy', '2018-06-01', '09:30:00', '14:00:00'),
(2, 'dendy', '2018-06-01', '14:00:00', '18:00:00'),
(3, 'dendy', '2018-06-04', '08:00:00', '11:50:00'),
(4, 'dendy', '2018-06-04', '13:00:00', '18:15:00'),
(5, 'balaton', '2018-06-01', '05:00:00', '13:00:00'),
(6, 'balaton', '2018-06-04', '13:00:00', '21:00:00');

--
-- Déclencheurs `horaire`
--
DROP TRIGGER IF EXISTS `insert_erreur`;
DELIMITER $$
CREATE TRIGGER `insert_erreur` BEFORE INSERT ON `horaire` FOR EACH ROW BEGIN
  DECLARE _msg  varchar(255);
 
  if (new.debut >= new.fin) then
        set _msg = concat('Insertion interdite ! Horaire debut plus grand que horaire fin !');
     SIGNAL SQLSTATE VALUE '08888' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 8888;
  end if;
  if exists (select 1 from horaire where login = new.login and jour = new.jour and fin > new.debut and debut < new.fin) then
		set _msg = concat('Insertion interdite ! Les horaires recoupent des horaires déjà saisis !');
     SIGNAL SQLSTATE VALUE '07777' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 7777;
  end if;
END
$$
DELIMITER ;
DROP TRIGGER IF EXISTS `update_erreur`;
DELIMITER $$
CREATE TRIGGER `update_erreur` BEFORE UPDATE ON `horaire` FOR EACH ROW BEGIN
  DECLARE _msg  varchar(255);
 
  if (new.debut >= new.fin) then
         set _msg = concat('Modification interdite ! Horaire debut plus grand que horaire fin !');
     SIGNAL SQLSTATE VALUE '08888' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 8888;
  end if;
  if exists (select 1 from horaire where id != new.id and login=new.login and jour = new.jour and fin > new.debut and debut < new.fin) then
        set _msg = concat('Modification interdite ! Les horaires recoupent des horaires déjà saisis !');
     SIGNAL SQLSTATE VALUE '07777' SET MESSAGE_TEXT = _msg, MYSQL_ERRNO = 7777;
  end if;
 
END
$$
DELIMITER ;


--
-- Doublure de structure pour la vue `v_an`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_an`;
CREATE TABLE IF NOT EXISTS `v_an` (
`an` varchar(4)
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_an_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_an_agent`;
CREATE TABLE IF NOT EXISTS `v_an_agent` (
`login` varchar(22)
,`an` varchar(4)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_jour`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_jour`;
CREATE TABLE IF NOT EXISTS `v_jour` (
`jour` date
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_jour_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_jour_agent`;
CREATE TABLE IF NOT EXISTS `v_jour_agent` (
`login` varchar(22)
,`jour` date
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_mois`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_mois`;
CREATE TABLE IF NOT EXISTS `v_mois` (
`mois` varchar(7)
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_mois_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_mois_agent`;
CREATE TABLE IF NOT EXISTS `v_mois_agent` (
`login` varchar(22)
,`mois` varchar(7)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_semaine`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_semaine`;
CREATE TABLE IF NOT EXISTS `v_semaine` (
`semaine` varchar(14)
,`cumul` time
,`login` varchar(22)
);

-- --------------------------------------------------------

--
-- Doublure de structure pour la vue `v_semaine_agent`
-- (Voir ci-dessous la vue réelle)
--
DROP VIEW IF EXISTS `v_semaine_agent`;
CREATE TABLE IF NOT EXISTS `v_semaine_agent` (
`login` varchar(22)
,`semaine` varchar(14)
,`cumul` time
);

-- --------------------------------------------------------

--
-- Structure de la vue `v_an`
--
DROP TABLE IF EXISTS `v_an`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_an`  AS  select distinct date_format(`horaire`.`jour`,'%Y') AS `an`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by date_format(`horaire`.`jour`,'%Y'),`horaire`.`login` order by date_format(`horaire`.`jour`,'%Y') desc,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_an_agent`
--
DROP TABLE IF EXISTS `v_an_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_an_agent`  AS  select distinct `horaire`.`login` AS `login`,date_format(`horaire`.`jour`,'%Y') AS `an`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul` from `horaire` group by `horaire`.`login`,date_format(`horaire`.`jour`,'%Y') order by `horaire`.`login`,date_format(`horaire`.`jour`,'%Y') desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_jour`
--
DROP TABLE IF EXISTS `v_jour`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_jour`  AS  select distinct `horaire`.`jour` AS `jour`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by `horaire`.`jour`,`horaire`.`login` order by `horaire`.`jour` desc,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_jour_agent`
--
DROP TABLE IF EXISTS `v_jour_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_jour_agent`  AS  select distinct `horaire`.`login` AS `login`,`horaire`.`jour` AS `jour`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul` from `horaire` group by `horaire`.`login`,`horaire`.`jour` order by `horaire`.`login`,`horaire`.`jour` desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_mois`
--
DROP TABLE IF EXISTS `v_mois`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_mois`  AS  select distinct date_format(`horaire`.`jour`,'%Y-%m') AS `mois`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by date_format(`horaire`.`jour`,'%Y-%m'),`horaire`.`login` order by date_format(`horaire`.`jour`,'%Y-%m') desc,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_mois_agent`
--
DROP TABLE IF EXISTS `v_mois_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_mois_agent`  AS  select distinct `horaire`.`login` AS `login`,date_format(`horaire`.`jour`,'%Y-%m') AS `mois`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul` from `horaire` group by `horaire`.`login`,date_format(`horaire`.`jour`,'%Y-%m') order by `horaire`.`login`,date_format(`horaire`.`jour`,'%Y-%m') desc ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_semaine`
--
DROP TABLE IF EXISTS `v_semaine`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_semaine`  AS  select distinct date_format(`horaire`.`jour`,'%Y-%m Sem %u') AS `semaine`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul`,`horaire`.`login` AS `login` from `horaire` group by date_format(`horaire`.`jour`,'%Y-%m Sem %u'),`horaire`.`login` order by date_format(`horaire`.`jour`,'%Y-%m Sem %u') desc,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) desc,`horaire`.`login` ;

-- --------------------------------------------------------

--
-- Structure de la vue `v_semaine_agent`
--
DROP TABLE IF EXISTS `v_semaine_agent`;

CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v_semaine_agent`  AS  select distinct `horaire`.`login` AS `login`,date_format(`horaire`.`jour`,'%Y-%m Sem %u') AS `semaine`,sec_to_time(sum(time_to_sec(timediff(`horaire`.`fin`,`horaire`.`debut`)))) AS `cumul` from `horaire` group by `horaire`.`login`,date_format(`horaire`.`jour`,'%Y-%m Sem %u') order by `horaire`.`login`,date_format(`horaire`.`jour`,'%Y-%m Sem %u') desc ;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
